using System;
using System.Collections.Generic;
using System.Globalization;

namespace Turbo.Plugins.Default
{

    public class ImpaleFramePlugin : BasePlugin, IInGameTopPainter
    {

        public HorizontalTopLabelList LabelList { get; private set; }

        public ImpaleFramePlugin()
            : base()
        {
            Enabled = true;
        }

        public override void Load(IController hud)
        {
            base.Load(hud);

            LabelList = new HorizontalTopLabelList(hud);

            LabelList.LeftFunc = () =>
            {
                return Hud.Window.Size.Width / 2.02f;
            };
            LabelList.TopFunc = () =>
            {
                return Hud.Window.Size.Height * 0.351f;
            };
            LabelList.WidthFunc = () =>
            {
                return Hud.Window.Size.Height * 0.02f;
            };
            LabelList.HeightFunc = () =>
            {
                return Hud.Window.Size.Height * 0.015f;
            };
						
            LabelList.LabelDecorators.Add(new TopLabelDecorator(Hud)
            {								
				TextFont = Hud.Render.CreateFont("tahoma", 8, 255, 0, 255, 0, true, false, true),
                BackgroundTexture1 = Hud.Texture.ButtonTextureGray,
                BackgroundTexture2 = Hud.Texture.BackgroundTextureOrange,
                BackgroundTextureOpacity1 = 1.0f,
                BackgroundTextureOpacity2 = 0.5f,
				TextFunc = () => (Hud.Game.Me.Offense.AttackSpeed < 2.3226) ? "26" : (Hud.Game.Me.Offense.AttackSpeed< 2.4194) ? "25" : (Hud.Game.Me.Offense.AttackSpeed< 2.5246) ? "24" :(Hud.Game.Me.Offense.AttackSpeed< 2.6393) ? "23" :(Hud.Game.Me.Offense.AttackSpeed< 2.765) ? "22" :(Hud.Game.Me.Offense.AttackSpeed< 2.9033) ? "21" :(Hud.Game.Me.Offense.AttackSpeed< 3.0561) ? "20" :(Hud.Game.Me.Offense.AttackSpeed< 3.2259) ? "19" :(Hud.Game.Me.Offense.AttackSpeed< 3.4156) ? "18" :(Hud.Game.Me.Offense.AttackSpeed< 3.6291) ? "17" :(Hud.Game.Me.Offense.AttackSpeed< 3.871) ? "16" :"15",
            });

        }

        public void PaintTopInGame(ClipState clipState)
        {
            if (clipState != ClipState.BeforeClip) return;

            LabelList.Paint();
        }
    }

}